/*
 File: dp_2sym.cpp
 Date and Time: Sat Jan 31 11:58:36 2015 
*/
#include "dp_2.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_dp_2;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Cdp_2::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rs_:{
       Rs* sym;
     if(re->rule_ == 0){
       sym = new Rs(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rs*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rs1_:{
       Rs1* sym;
     if(re->rule_ == 0){
       sym = new Rs1(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rs1*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rs1_:{
       Rs1* sym;
     if(re->rule_ == 0){
       sym = new Rs1(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rs1*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs3_Rs1_:{
       Rs1* sym;
     if(re->rule_ == 0){
       sym = new Rs1(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rs1*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_Rb_:{
       Rb* sym;
     if(re->rule_ == 0){
       sym = new Rb(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rb*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rc_:{
       Rc* sym;
     if(re->rule_ == 0){
       sym = new Rc(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rc*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rd_:{
       Rd* sym;
     if(re->rule_ == 0){
       sym = new Rd(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rd*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs1_Re_:{
       Re* sym;
     if(re->rule_ == 0){
       sym = new Re(parser__);
       re->rule_ = sym;
     }else{
       sym = (Re*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    default: return;
   }
}
